import Foundation
import Capacitor
import CallKit

/**
 * Please read the Capacitor iOS Plugin Development Guide
 * here: https://capacitorjs.com/docs/plugins/ios
 */
@objc(NativeCall)
public class NativeCall: CAPPlugin {
    

    
    @objc public func incomingCall(_ call: CAPPluginCall) {
        reportIncomingCall()
        call.success([
            "connected": "true"
        ])
    }


    static var providerConfiguration: CXProviderConfiguration = {
      let providerConfiguration = CXProviderConfiguration(localizedName: "Saam")
      
      providerConfiguration.supportsVideo = false
      providerConfiguration.maximumCallsPerCallGroup = 1
      providerConfiguration.supportedHandleTypes = [.generic]
      
      return providerConfiguration
    }()


    public func reportIncomingCall() {
        let update = CXCallUpdate()
        update.remoteHandle = CXHandle(type: .generic, value: "Saam")
         let provider: CXProvider
          provider = CXProvider(configuration: NativeCall.providerConfiguration)
          provider.setDelegate(self, queue: nil)
        DispatchQueue.main.async{
            provider.reportNewIncomingCall(with: UUID(), update: update, completion: { error in })
            
        }
       
    }

}

extension NativeCall: CXProviderDelegate {

    public func providerDidReset(_ provider: CXProvider) {
        print("did reset")
    }

    public func provider(_ provider: CXProvider, perform action: CXAnswerCallAction) {
        action.fulfill()
    }

    public func provider(_ provider: CXProvider, perform action: CXEndCallAction) {
        action.fulfill()
    }
}

